CON
  NUM_BEHAVIORS = 4
  SPEED_BASE = 2 *  NUM_BEHAVIORS
  TURN_RATE_BASE = 3 * NUM_BEHAVIORS
  ESCAPE_PRIORITY = 0
  ATTACK_PRIORITY = 1
  PURSUE_PRIORITY = 2
  DRIVE_PRIORITY = 3
  LEFT = 1
  LEFT_LIMIT = 1000
  RIGHT = 0
  RIGHT_LIMIT = 1000
  CENTER = 2
OBJ 
    sumoBot : "SumoBot"

PUB Main(dataAddr)  | howHit
  sumoBot.Init
  long[dataAddr][ESCAPE_PRIORITY] := false 
  repeat
    if long[dataAddr][ESCAPE_PRIORITY] AND howHit == LEFT
      long[dataAddr][SPEED_BASE+ESCAPE_PRIORITY] := -100
      long[dataAddr][TURN_RATE_BASE+ESCAPE_PRIORITY] := 0
      waitcnt(clkfreq + cnt)
      long[dataAddr][TURN_RATE_BASE+ESCAPE_PRIORITY] := 45                   ' degrees/sec
      long[dataAddr][SPEED_BASE+ESCAPE_PRIORITY] := 0
      waitcnt(clkfreq + cnt)
      long[dataAddr][ESCAPE_PRIORITY] := false
    elseif long[dataAddr][ESCAPE_PRIORITY] AND howHit == RIGHT
      long[dataAddr][SPEED_BASE+ESCAPE_PRIORITY] := -100
      long[dataAddr][TURN_RATE_BASE+ESCAPE_PRIORITY] := 0
      waitcnt(clkfreq + cnt)
      long[dataAddr][TURN_RATE_BASE+ESCAPE_PRIORITY] := -45                   ' degrees/sec
      long[dataAddr][SPEED_BASE+ESCAPE_PRIORITY] := 0
      waitcnt(clkfreq + cnt)
      long[dataAddr][ESCAPE_PRIORITY] := false
    elseif long[dataAddr][ESCAPE_PRIORITY] AND howHit == CENTER
      long[dataAddr][SPEED_BASE+ESCAPE_PRIORITY] := -100
      long[dataAddr][TURN_RATE_BASE+ESCAPE_PRIORITY] := 0
      waitcnt(clkfreq + cnt)
      long[dataAddr][TURN_RATE_BASE+ESCAPE_PRIORITY] := 45                   ' degrees/sec
      long[dataAddr][SPEED_BASE+ESCAPE_PRIORITY] := 0
      waitcnt(clkfreq * 3 + cnt)                        ' 135 degrees
      long[dataAddr][ESCAPE_PRIORITY] := false
    if SumoBot.GetAnalog(LEFT) < LEFT_LIMIT  
      long[dataAddr][ESCAPE_PRIORITY] := true
      howHit := LEFT
    elseif  SumoBot.GetAnalog(RIGHT) < RIGHT_LIMIT
      long[dataAddr][ESCAPE_PRIORITY] := true
      howHit := RIGHT      
    elseif SumoBot.GetAnalog(LEFT) <  LEFT_LIMIT AND  SumoBot.GetAnalog(RIGHT) < RIGHT_LIMIT
      long[dataAddr][ESCAPE_PRIORITY] := true
      howHit := CENTER                  